unit ooenet_Server_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, generalhelpers, enet, ooenet;

type

  { TForm1 }

  TForm1 = class(TForm)
   Button1: TButton;
   Button2: TButton;
   Button3: TButton;
   Button4: TButton;
   Edit2: TEdit;
   Label2: TLabel;
   ListBox1: TListBox;
   Timer1: TTimer;
   procedure Button1Click(Sender: TObject);
   procedure Button2Click(Sender: TObject);
   procedure Button3Click(Sender: TObject);
   procedure Button4Click(Sender: TObject);
   procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  aServer:TEnetHost = nil;
  host:PENetHost = nil;

implementation

{$R *.lfm}

{ TForm1 }

procedure log(s:string);
begin
Form1.ListBox1.Items.Add(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
var ip: ENetAddress;
    aPort:integer = 58000;
begin
if not TryStrtoInt(Edit2.Text,aPort) then aPort := 58000;
aServer := TEnetHost.create(nil,aPort,512,0,0);
Timer1.Enabled:= True;
Button1.Enabled:= False;
Button2.Enabled:= False;
end;

procedure TForm1.Button2Click(Sender: TObject);
var ip: ENetAddress;
    aPort:integer = 58000;
begin
if not TryStrtoInt(Edit2.Text,aPort) then aPort := 58000;
ip.host:=ENET_HOST_ANY;
ip.port:=aPort;

host:=enet_host_create(@ip, 256, {$IFNDEF ENET12}1,{$ENDIF} 0, 0);
Timer1.Enabled:= True;
Button1.Enabled:= False;
Button2.Enabled:= False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if assigned(aServer) then FreeAndNil(aServer);
if assigned(host) then
   begin
   enet_host_destroy(host);
   host := nil;
   end;
Button1.Enabled:= True;
Button2.Enabled:= True;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  s:string;
  i:integer;
begin
if InputQuery('Eingabe', 'Was soll verschickt werden', TRUE, s) then
   begin
   if assigned(aServer) then
      begin
      for i := 0 to aServer.count-1 do aServer.client[i].send(s,[pfReliable]);
      end;
   if assigned(host) then enet_host_broadcast_string(host,s,0);
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var s: string;

    event: ENetEvent;
    pufferhost:PENetHost;
begin
//aServer.handleReceives(0);
if assigned(aServer) then pufferhost := aServer.host // OO Method // i Edited TEnetHost, so that it has an property host which reads fhost!
   else if assigned(host) then pufferhost := host  // normal Method
        else exit;  // no Server on
while enet_host_service(pufferhost, @event,0) > 0 do
 begin
 case event.typ of
  ENET_EVENT_TYPE_CONNECT:
     begin
     log('Player  joined' + enet_address_string(event.peer^.address));
     end;
  ENET_EVENT_TYPE_DISCONNECT:
     begin
     log('Player  disconect' + enet_address_string(event.peer^.address));
     end;
  ENET_EVENT_TYPE_RECEIVE:
     begin
     if event.packet^.dataLength>0 then
        begin
        setlength(s, event.packet^.dataLength);
        move((event.packet^.data)^, s[1], event.packet^.dataLength);
        log(enet_address_string(event.peer^.address) + ' send msg(' + InttoStr(length(s)) + '): "' + s + '"');
        enet_packet_destroy(event.packet);
        s := '';
        end;
    end;
 end;
 end;
end;

end.

